> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Create General Journal

POST https://api.npretail.app/{tenant}/{environment}/{company}/finance/generaljournal
Content-Type: application/json

Creates a new general journal with header and lines in a single request.

Reference: https://docs.navipartner.com/apis/api-reference/finance/gljournal/create-general-journal

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)

### Body (application/json)

This endpoint expects a GeneralJournalPost.

- `code` (string, required) — The code for the new journal batch.
- `lines` (list of GeneralJournalLinePost, required) — A list of lines to create within the new journal.
- `description` (string, optional) — The display name (description) for the new journal batch.

## Response

### 200

- `id` (UUID, required) — The unique identifier for the journal.
- `code` (string, required) — The code for the journal batch.
- `lastModifiedDateTime` (datetime, required) — The date and time the journal was last modified.
- `lines` (list of GeneralJournalLine, required) — A list of the lines within this journal.
- `displayName` (string, optional) — The display name (description) of the journal batch.
- `templateDisplayName` (string, optional) — The name of the journal template this journal is based on.
- `balancingAccountId` (UUID, optional) — The default balancing account ID for the journal lines.
- `balancingAccountNumber` (string, optional) — The default balancing account number for the journal lines.

## Types

### GeneralJournalLinePost

Defines the data needed to create a new general journal line.

- `postingDate` (date, required) — The posting date for the transaction.
- `documentNumber` (string, required) — The document number for the transaction.
- `amount` (double, required) — The amount of the transaction.
- `accountNumber` (string, optional) — The number of the main account for this line. Either this or accountId must be provided.
- `accountId` (UUID, optional) — The ID of the main account for this line. Either this or accountNumber must be provided.
- `description` (string, optional) — A description of the transaction.
- `accountType` (enum, optional) — The type of the main account. Defaults to 'G/L Account'.
  - Allowed values: `G/L Account`, `Bank Account`
- `externalDocumentNumber` (string, optional) — An external document number, if applicable.
- `comment` (string, optional) — A comment for the line.
- `taxCode` (string, optional) — The tax code to apply.
- `balancingAccountNumber` (string, optional) — The balancing account number for this line.

### GeneralJournalLine

Represents a single line within a general journal.

- `id` (UUID, required) — The unique identifier for the journal line.
- `journalId` (UUID, required) — The unique identifier of the journal this line belongs to.
- `lineNumber` (integer, required) — The line number within the journal.
- `accountType` (enum, required) — The type of the main account.
  - Allowed values: `G/L Account`, `Bank Account`
- `accountNumber` (string, required) — The number of the main account.
- `postingDate` (date, required) — The date the transaction will be posted.
- `documentNumber` (string, required) — A number for the document.
- `amount` (double, required) — The transaction amount.
- `lastModifiedDateTime` (datetime, required) — The date and time the line was last modified.
- `journalDisplayName` (string, optional) — The display name of the journal.
- `accountId` (UUID, optional) — The unique identifier of the main account.
- `externalDocumentNumber` (string, optional) — An external number for the document.
- `description` (string, optional) — A description for the transaction.
- `comment` (string, optional) — A comment for the line.
- `taxCode` (string, optional) — The tax code for the line.
- `balanceAccountType` (enum, optional) — The type of the balancing account.
  - Allowed values: `G/L Account`, `Bank Account`
- `balancingAccountId` (UUID, optional) — The unique identifier of the balancing account.
- `balancingAccountNumber` (string, optional) — The number of the balancing account.

## Examples

**Request**

```json
{
  "code": "DAILY",
  "lines": [
    {
      "postingDate": "2025-06-20",
      "documentNumber": "INV-2025-001",
      "amount": 1250.75,
      "accountNumber": "10100",
      "description": "Office Supplies",
      "balancingAccountNumber": "BANK-US"
    },
    {
      "postingDate": "2025-06-20",
      "documentNumber": "INV-2025-002",
      "amount": 500,
      "accountNumber": "60200",
      "description": "Catering for meeting",
      "balancingAccountNumber": "BANK-US"
    }
  ],
  "description": "Daily Journal Entries"
}
```

**Response**

```json
{
  "id": "e9f5e5e0-8f6a-4f2b-8a1a-1e1e1e1e1e1e",
  "code": "DAILY",
  "lastModifiedDateTime": "2025-06-20T14:30:00Z",
  "lines": [
    {
      "id": "d2d7fb2a-6091-4e4c-a4c3-633d1354b2a3",
      "journalId": "e9f5e5e0-8f6a-4f2b-8a1a-1e1e1e1e1e1e",
      "lineNumber": 10000,
      "accountType": "G/L Account",
      "accountNumber": "10100",
      "postingDate": "2025-06-20",
      "documentNumber": "INV-2025-001",
      "amount": 1250.75,
      "lastModifiedDateTime": "2025-06-20T14:30:00Z",
      "journalDisplayName": "Daily Journal",
      "accountId": "a1b2c3d4-e5f6-4a7b-8c9d-0e1f2a3b4c5d",
      "externalDocumentNumber": "EXT-INV-001",
      "description": "Office Supplies Purchase",
      "comment": "Approved by manager",
      "taxCode": "VAT25",
      "balanceAccountType": "Bank Account",
      "balancingAccountId": "f1e2d3c4-b5a6-4f7e-8d9c-0a1b2c3d4e5f",
      "balancingAccountNumber": "BANK-US"
    }
  ],
  "displayName": "Daily Journal",
  "templateDisplayName": "GENERAL",
  "balancingAccountId": "f1e2d3c4-b5a6-4f7e-8d9c-0a1b2c3d4e5f",
  "balancingAccountNumber": "BANK-US"
}
```

**SDK Code**

```python Create Daily Journal
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal"

payload = {
    "code": "DAILY",
    "lines": [
        {
            "postingDate": "2025-06-20",
            "documentNumber": "INV-2025-001",
            "amount": 1250.75,
            "accountNumber": "10100",
            "description": "Office Supplies",
            "balancingAccountNumber": "BANK-US"
        },
        {
            "postingDate": "2025-06-20",
            "documentNumber": "INV-2025-002",
            "amount": 500,
            "accountNumber": "60200",
            "description": "Catering for meeting",
            "balancingAccountNumber": "BANK-US"
        }
    ],
    "description": "Daily Journal Entries"
}
headers = {
    "x-np-api-key": "<NaviPartner API Key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create Daily Journal
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal';
const options = {
  method: 'POST',
  headers: {'x-np-api-key': '<NaviPartner API Key>', 'Content-Type': 'application/json'},
  body: '{"code":"DAILY","lines":[{"postingDate":"2025-06-20","documentNumber":"INV-2025-001","amount":1250.75,"accountNumber":"10100","description":"Office Supplies","balancingAccountNumber":"BANK-US"},{"postingDate":"2025-06-20","documentNumber":"INV-2025-002","amount":500,"accountNumber":"60200","description":"Catering for meeting","balancingAccountNumber":"BANK-US"}],"description":"Daily Journal Entries"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create Daily Journal
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal"

	payload := strings.NewReader("{\n  \"code\": \"DAILY\",\n  \"lines\": [\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-001\",\n      \"amount\": 1250.75,\n      \"accountNumber\": \"10100\",\n      \"description\": \"Office Supplies\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    },\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-002\",\n      \"amount\": 500,\n      \"accountNumber\": \"60200\",\n      \"description\": \"Catering for meeting\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    }\n  ],\n  \"description\": \"Daily Journal Entries\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create Daily Journal
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"code\": \"DAILY\",\n  \"lines\": [\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-001\",\n      \"amount\": 1250.75,\n      \"accountNumber\": \"10100\",\n      \"description\": \"Office Supplies\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    },\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-002\",\n      \"amount\": 500,\n      \"accountNumber\": \"60200\",\n      \"description\": \"Catering for meeting\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    }\n  ],\n  \"description\": \"Daily Journal Entries\"\n}"

response = http.request(request)
puts response.read_body
```

```java Create Daily Journal
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"code\": \"DAILY\",\n  \"lines\": [\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-001\",\n      \"amount\": 1250.75,\n      \"accountNumber\": \"10100\",\n      \"description\": \"Office Supplies\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    },\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-002\",\n      \"amount\": 500,\n      \"accountNumber\": \"60200\",\n      \"description\": \"Catering for meeting\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    }\n  ],\n  \"description\": \"Daily Journal Entries\"\n}")
  .asString();
```

```php Create Daily Journal
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal', [
  'body' => '{
  "code": "DAILY",
  "lines": [
    {
      "postingDate": "2025-06-20",
      "documentNumber": "INV-2025-001",
      "amount": 1250.75,
      "accountNumber": "10100",
      "description": "Office Supplies",
      "balancingAccountNumber": "BANK-US"
    },
    {
      "postingDate": "2025-06-20",
      "documentNumber": "INV-2025-002",
      "amount": 500,
      "accountNumber": "60200",
      "description": "Catering for meeting",
      "balancingAccountNumber": "BANK-US"
    }
  ],
  "description": "Daily Journal Entries"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp Create Daily Journal
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal");
var request = new RestRequest(Method.POST);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"code\": \"DAILY\",\n  \"lines\": [\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-001\",\n      \"amount\": 1250.75,\n      \"accountNumber\": \"10100\",\n      \"description\": \"Office Supplies\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    },\n    {\n      \"postingDate\": \"2025-06-20\",\n      \"documentNumber\": \"INV-2025-002\",\n      \"amount\": 500,\n      \"accountNumber\": \"60200\",\n      \"description\": \"Catering for meeting\",\n      \"balancingAccountNumber\": \"BANK-US\"\n    }\n  ],\n  \"description\": \"Daily Journal Entries\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create Daily Journal
import Foundation

let headers = [
  "x-np-api-key": "<NaviPartner API Key>",
  "Content-Type": "application/json"
]
let parameters = [
  "code": "DAILY",
  "lines": [
    [
      "postingDate": "2025-06-20",
      "documentNumber": "INV-2025-001",
      "amount": 1250.75,
      "accountNumber": "10100",
      "description": "Office Supplies",
      "balancingAccountNumber": "BANK-US"
    ],
    [
      "postingDate": "2025-06-20",
      "documentNumber": "INV-2025-002",
      "amount": 500,
      "accountNumber": "60200",
      "description": "Catering for meeting",
      "balancingAccountNumber": "BANK-US"
    ]
  ],
  "description": "Daily Journal Entries"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./finance/generaljournal")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```